## tigervnc-1.12.0.tar.gz.e92945f43654e2a120f2c9d8b3a9b869

=== common/CMakeLists.txt ===
add_subdirectory(os)
add_subdirectory(rdr)
add_subdirectory(network)
add_subdirectory(rfb)

# For any convenience libraries that are linked into libvnc.so, we need to
# explicitly build their corresponding sources using PIC.  WIN32 is excluded
# because PIC code does not exist on that platform and MinGW complains if -fPIC
# is passed (additionally, libvnc is not used on Windows.)

if(NOT WIN32)
  set_target_properties(os rdr network rfb
    PROPERTIES COMPILE_FLAGS -fPIC)
endif()

=== media/CMakeLists.txt ===
set(ICON_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_16.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_22.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_24.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_32.png
  ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_48.png)

find_program(CONVERT_EXECUTABLE convert)

if(CONVERT_EXECUTABLE)
  add_custom_target(icons DEPENDS ${ICON_FILES})

  if(UNIX AND NOT APPLE)
    foreach(SIZE 16 22 24 32 48)
      install(FILES icons/tigervnc_${SIZE}.png
        DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${SIZE}x${SIZE}/apps
        RENAME tigervnc.png)
    endforeach()
    install(FILES icons/tigervnc.svg
      DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/scalable/apps)
  endif()
endif()

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_16.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8 -background transparent
    ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_16.svg
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_16.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_16.svg
  COMMENT "Generating icons/tigervnc_16.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_22.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -size 22x22 xc:none -gravity center -background transparent
    -size 20x20 ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_20.svg
    -composite ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_22.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_20.svg
  COMMENT "Generating icons/tigervnc_22.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_24.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -size 24x24 xc:none -gravity center -background transparent
    -size 20x20 ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_20.svg
    -composite ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_24.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_20.svg
  COMMENT "Generating icons/tigervnc_24.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_32.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -size 32x32 xc:none -gravity center -background transparent
    -size 28x28 ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_28.svg
    -composite ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_32.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_28.svg
  COMMENT "Generating icons/tigervnc_32.png")

add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_48.png
  COMMAND ${CONVERT_EXECUTABLE} -depth 8
    -size 48x48 xc:none -gravity center -background transparent
    -size 42x42 ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_42.svg
    -composite ${CMAKE_CURRENT_SOURCE_DIR}/icons/tigervnc_48.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/tigervnc_42.svg
  COMMENT "Generating icons/tigervnc_48.png")

=== po/CMakeLists.txt ===
# Gettext support - mostly borrowed from the Licq project

file(STRINGS LINGUAS po_FILES)

if (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)
  message(FATAL_ERROR "Gettext message catalog tools NOT found")
endif (NOT GETTEXT_MSGMERGE_EXECUTABLE AND NOT GETTEXT_MSGFMT_EXECUTABLE)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if (GETTEXT_XGETTEXT_EXECUTABLE)
  # Get list of all source files
  file(GLOB_RECURSE po_source
    RELATIVE ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/vncviewer/*.h
    ${PROJECT_SOURCE_DIR}/vncviewer/*.cxx
    ${PROJECT_SOURCE_DIR}/vncviewer/*.desktop.in.in
  )

  add_custom_target(translations_update
    ${GETTEXT_XGETTEXT_EXECUTABLE}
      "--directory=${PROJECT_SOURCE_DIR}"
      "--output=${CMAKE_CURRENT_SOURCE_DIR}/tigervnc.pot"
      --default-domain=tigervnc
      --keyword=_
      --keyword=p_:1c,2
      --keyword=N_
      "--copyright-holder=TigerVNC Team and many others \(see README.rst\)"
      --msgid-bugs-address=tigervnc-devel@googlegroups.com
      --sort-by-file
      --add-location
      --add-comments=TRANSLATORS
      ${po_source}
    COMMENT "Updating tigervnc.pot"
    VERBATIM
  )
endif (GETTEXT_XGETTEXT_EXECUTABLE)

foreach(lang ${po_FILES})
  set(po  "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
  set(mo "${CMAKE_CURRENT_BINARY_DIR}/${lang}.mo")

  # Add command to build X.mo from X.po
  add_custom_command(OUTPUT ${mo}
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} --check -o ${mo} ${po}
    DEPENDS ${po}
  )

  install(FILES ${mo}
    DESTINATION "${CMAKE_INSTALL_FULL_LOCALEDIR}/${lang}/LC_MESSAGES"
    RENAME tigervnc.mo
  )

  set(moFiles ${moFiles} ${mo})
endforeach(lang)

add_custom_target(translations ALL DEPENDS ${moFiles})

=== release/CMakeLists.txt ===
# This file is included from the top-level CMakeLists.txt.  We just store it
# here to avoid cluttering up that file.


#
# Windows installer (Inno Setup)
#

if(WIN32)

if(CMAKE_SIZEOF_VOID_P MATCHES 8)
  set(INST_SUFFIX 64)
  set(INST_DEFS -DWIN64)
endif()

configure_file(tigervnc.iss.in tigervnc.iss)

add_custom_target(installer
  iscc -o. ${INST_DEFS} -F${CMAKE_PROJECT_NAME}${INST_SUFFIX}-${VERSION} tigervnc.iss
  DEPENDS vncviewer
  SOURCES tigervnc.iss)

if(BUILD_WINVNC)
  configure_file(winvnc.iss.in winvnc.iss)

  add_custom_target(winvnc_installer
    iscc -o. ${INST_DEFS} -F${CMAKE_PROJECT_NAME}${INST_SUFFIX}-winvnc-${VERSION} winvnc.iss
    DEPENDS winvnc4 wm_hooks vncconfig
    SOURCES winvnc.iss)
endif()

endif() # WIN32


#
# Mac DMG
#

if(APPLE)

set(DEFAULT_OSX_X86_BUILD ${CMAKE_SOURCE_DIR}/osxx86)
set(OSX_X86_BUILD ${DEFAULT_OSX_X86_BUILD} CACHE PATH
  "Directory containing 32-bit OS X build to include in universal binaries (default: ${DEFAULT_OSX_X86_BUILD})")

configure_file(makemacapp.in makemacapp)
configure_file(Info.plist.in Info.plist)

add_custom_target(dmg sh makemacapp
  DEPENDS vncviewer
  SOURCES makemacapp)

add_custom_target(udmg sh makemacapp universal
  DEPENDS vncviewer
  SOURCES makemacapp)

endif() # APPLE


#
# Binary tarball
#

if(UNIX)

configure_file(maketarball.in maketarball)

set(TARBALL_DEPENDS vncviewer vncpasswd vncconfig)
if(BUILD_JAVA)
  set(TARBALL_DEPENDS ${TARBALL_DEPENDS} java)
endif()

add_custom_target(tarball bash maketarball
  DEPENDS ${TARBALL_DEPENDS}
  SOURCES maketarball)

add_custom_target(servertarball bash maketarball server
  DEPENDS ${TARBALL_DEPENDS}
  SOURCES maketarball)

endif() #UNIX

#
# Common
#

install(FILES ${CMAKE_SOURCE_DIR}/LICENCE.TXT DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})
install(FILES ${CMAKE_SOURCE_DIR}/README.rst DESTINATION ${CMAKE_INSTALL_FULL_DOCDIR})

=== tests/CMakeLists.txt ===
# Benchmarking tools
add_subdirectory(perf)

# Unit tests
add_subdirectory(unit)

=== common/rfb/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common ${JPEG_INCLUDE_DIR} ${PIXMAN_INCLUDE_DIR})

set(RFB_SOURCES
  Blacklist.cxx
  Congestion.cxx
  CConnection.cxx
  CMsgHandler.cxx
  CMsgReader.cxx
  CMsgWriter.cxx
  CSecurityPlain.cxx
  CSecurityStack.cxx
  CSecurityVeNCrypt.cxx
  CSecurityVncAuth.cxx
  ClientParams.cxx
  ComparingUpdateTracker.cxx
  Configuration.cxx
  CopyRectDecoder.cxx
  Cursor.cxx
  DecodeManager.cxx
  Decoder.cxx
  d3des.c
  EncodeManager.cxx
  Encoder.cxx
  HextileDecoder.cxx
  HextileEncoder.cxx
  JpegCompressor.cxx
  JpegDecompressor.cxx
  KeyRemapper.cxx
  LogWriter.cxx
  Logger.cxx
  Logger_file.cxx
  Logger_stdio.cxx
  Password.cxx
  PixelBuffer.cxx
  PixelFormat.cxx
  RREEncoder.cxx
  RREDecoder.cxx
  RawDecoder.cxx
  RawEncoder.cxx
  Region.cxx
  SConnection.cxx
  SMsgHandler.cxx
  SMsgReader.cxx
  SMsgWriter.cxx
  ServerCore.cxx
  ServerParams.cxx
  Security.cxx
  SecurityServer.cxx
  SecurityClient.cxx
  SSecurityPlain.cxx
  SSecurityStack.cxx
  SSecurityVncAuth.cxx
  SSecurityVeNCrypt.cxx
  ScaleFilters.cxx
  Timer.cxx
  TightDecoder.cxx
  TightEncoder.cxx
  TightJPEGEncoder.cxx
  UpdateTracker.cxx
  VNCSConnectionST.cxx
  VNCServerST.cxx
  ZRLEEncoder.cxx
  ZRLEDecoder.cxx
  encodings.cxx
  util.cxx)

if(UNIX)
  set(RFB_SOURCES ${RFB_SOURCES} Logger_syslog.cxx)
endif()

if(WIN32)
  include_directories(${CMAKE_SOURCE_DIR}/win)
  set(RFB_SOURCES ${RFB_SOURCES} WinPasswdValidator.cxx)
endif(WIN32)

set(RFB_LIBRARIES ${JPEG_LIBRARIES} ${PIXMAN_LIBRARY} os rdr)

if(UNIX AND NOT APPLE)
  set(RFB_SOURCES ${RFB_SOURCES} UnixPasswordValidator.cxx
    UnixPasswordValidator.h pam.c pam.h)
  set(RFB_LIBRARIES ${RFB_LIBRARIES} ${PAM_LIBS})
endif()

if(GNUTLS_FOUND)
  set(RFB_SOURCES
    ${RFB_SOURCES}
    CSecurityTLS.cxx
    SSecurityTLS.cxx
  )
  set(RFB_LIBRARIES
    ${RFB_LIBRARIES}
    ${GNUTLS_LIBRARIES}
  )
endif()

add_library(rfb STATIC ${RFB_SOURCES})

target_link_libraries(rfb ${RFB_LIBRARIES})

if(UNIX)
  libtool_create_control_file(rfb)
endif()

=== unix/common/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/unix/common)

add_library(unixcommon STATIC
  randr.cxx)

if(UNIX)
  libtool_create_control_file(unixcommon)
endif()

if(NOT WIN32)
  set_target_properties(unixcommon
    PROPERTIES COMPILE_FLAGS -fPIC)
endif()

=== unix/vncconfig/CMakeLists.txt ===
include_directories(${X11_INCLUDE_DIR})

include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/unix/tx)

add_executable(vncconfig 
  buildtime.c
  vncExt.c
  vncconfig.cxx
  QueryConnectDialog.cxx)

target_link_libraries(vncconfig tx rfb network rdr ${X11_LIBRARIES})

install(TARGETS vncconfig DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
install(FILES vncconfig.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 RENAME vncconfig.1)

=== win/rfb_win32/CMakeLists.txt ===
set(RFB_WIN32_SOURCES
  AboutDialog.cxx
  Clipboard.cxx
  CurrentUser.cxx
  DeviceContext.cxx
  DeviceFrameBuffer.cxx
  Dialog.cxx
  DIBSectionBuffer.cxx
  EventManager.cxx
  LaunchProcess.cxx
  ListViewControl.cxx
  MonitorInfo.cxx
  MsgWindow.cxx
  RegConfig.cxx
  Registry.cxx
  SecurityPage.cxx
  SDisplayCorePolling.cxx
  SDisplayCoreWMHooks.cxx
  SDisplay.cxx
  Security.cxx
  Service.cxx
  SInput.cxx
  SocketManager.cxx
  TCharArray.cxx
  TsSessions.cxx
  Win32Util.cxx
  WMCursor.cxx
  WMHooks.cxx
  WMNotifier.cxx
  WMPoller.cxx
  WMShatter.cxx
  WMWindowCopyRect.cxx)

if(BUILD_WINVNC)
  set(RFB_WIN32_SOURCES ${RFB_WIN32_SOURCES} CleanDesktop.cxx)
endif()

add_library(rfb_win32 STATIC ${RFB_WIN32_SOURCES})

target_link_libraries(rfb_win32 user32.lib comctl32.lib wtsapi32.lib version.lib)

=== win/vncconfig/CMakeLists.txt ===
include_directories(${CMAKE_BINARY_DIR}/win)

add_executable(vncconfig WIN32
  Legacy.cxx
  PasswordDialog.cxx
  vncconfig.cxx
  vncconfig.rc)

target_link_libraries(vncconfig rfb_win32 rfb network rdr ws2_32.lib)

install(TARGETS vncconfig
  RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
)

=== win/wm_hooks/CMakeLists.txt ===
include_directories(${CMAKE_BINARY_DIR}/win ${CMAKE_CURRENT_SOURCE_DIR})

add_library(wm_hooks SHARED
  ../wm_hooks/wm_hooks.cxx
  ../wm_hooks/wm_hooks.rc)

# We want the DLL to be named wm_hooks.dll rather than libwm_hooks.dll
set_target_properties(wm_hooks PROPERTIES PREFIX "")

install(TARGETS wm_hooks
  RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
)

=== contrib/packages/deb/ubuntu-focal/debian/control ===
Source: tigervnc
Section: x11
Priority: optional
Maintainer: Brian P. Hinz <bphinz@users.sourceforge.net>
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 9),dh-autoreconf,po-debconf,dpkg-dev (>= 1.16.1),quilt,lsb-release,pkg-config,bison,flex,xauth,xutils-dev (>= 1:7.6+4),xfonts-utils (>= 1:7.5+1),x11proto-bigreqs-dev (>= 1:1.1.0),x11proto-composite-dev (>= 1:0.4),x11proto-core-dev (>= 7.0.31),x11proto-damage-dev (>= 1.1),x11proto-fixes-dev (>= 1:5.0),x11proto-fonts-dev (>= 2.1.3),x11proto-kb-dev (>= 1.0.3),x11proto-xinerama-dev,x11proto-randr-dev (>= 1.5.0),x11proto-record-dev (>= 1.13.99.1),x11proto-render-dev (>= 2:0.11),x11proto-resource-dev (>= 1.2.0),x11proto-scrnsaver-dev,x11proto-video-dev,x11proto-xcmisc-dev (>= 1.2.0),x11proto-xext-dev (>= 7.2.99.901),x11proto-xf86bigfont-dev (>= 1.2.0),x11proto-xf86dga-dev (>= 2.0.99.1),x11proto-xf86vidmode-dev (>= 2.2.99.1),x11proto-present-dev,x11proto-dri3-dev,xtrans-dev (>= 1.3.5),libxau-dev (>= 1:1.0.5-2),x11proto-input-dev (>= 2.3),x11proto-dri2-dev (>= 2.8),libxdmcp-dev (>= 1:0.99.1),libxfont-dev (>= 1:2.0.1),libxkbfile-dev (>= 1:0.99.1),libpixman-1-dev (>= 0.27.2),libpciaccess-dev (>= 0.12.901),libgcrypt-dev,nettle-dev,libudev-dev (>= 151-3) [linux-any],libselinux1-dev (>= 2.0.80) [linux-any],libaudit-dev [linux-any],x11proto-xf86dri-dev (>= 2.1.0),libdrm-dev (>= 2.4.46) [!hurd-i386],x11proto-gl-dev (>= 1.4.17),libgl1-mesa-dev (>= 9.2),libxmuu-dev (>= 1:0.99.1),libxext-dev (>= 1:0.99.1),libx11-dev (>= 2:1.6),libxrender-dev (>= 1:0.9.0),libxi-dev (>= 2:1.6.99.1),x11proto-dmx-dev (>= 1:2.2.99.1),libdmx-dev (>= 1:1.0.1),libxpm-dev (>= 1:3.5.3),libxaw7-dev (>= 1:0.99.1),libxt-dev (>= 1:0.99.1),libxmu-dev (>= 1:0.99.1),libxtst-dev (>= 1:0.99.1),libxres-dev (>= 1:0.99.1),libxfixes-dev (>= 1:3.0.0),libxv-dev,libxinerama-dev,libxshmfence-dev (>= 1.1) [!hurd-i386],libepoxy-dev [linux-any kfreebsd-any],libegl1-mesa-dev [linux-any kfreebsd-any],libgbm-dev (>= 10.2) [linux-any kfreebsd-any],libxcb1-dev,libxcb-xkb-dev,libxcb-shape0-dev,libxcb-render0-dev,libxcb-render-util0-dev,libxcb-util0-dev,libxcb-image0-dev,libxcb-icccm4-dev,libxcb-shm0-dev,libxcb-keysyms1-dev,libxcb-randr0-dev,libxcb-xv0-dev,libxcb-glx0-dev,libxcb-xf86dri0-dev (>= 1.6),xkb-data,x11-xkb-utils,libbsd-dev,libwayland-dev [linux-any],wayland-protocols (>= 1.9) [linux-any],libdbus-1-dev (>= 1.0) [linux-any],libsystemd-dev [linux-any],libmirclient-dev (>= 0.13.1) [!powerpc !ppc64el !s390x],mir-client-platform-mesa-dev,zlib1g-dev,libjpeg-turbo8-dev,perl-modules,cmake,gnutls-dev,libpam0g-dev,libpng-dev,automake,autoconf,libtool,pkg-config,openjdk-8-jdk,xorg-server-source,libfltk1.3-dev,fluid,curl,bzip2,quilt,libosmesa6-dev,libgl1-mesa-dri,libgl1-mesa-glx,libxft-dev,xfonts-base,libexpat1-dev,libfontconfig1-dev,libglu1-mesa-dev,libxcursor-dev,libxrandr-dev,libcairo2-dev,mesa-common-dev
Homepage: http://www.tigervnc.com

Package: tigervncserver
Architecture: any
Provides: xserver, vnc-server
Depends: x11-common | xserver-common, x11-utils, xauth, libbz2-1.0, libc6, libfontenc1, libfreetype6, libgcc1, libgl1-mesa-dri, libgnutls30, libjpeg-turbo8, libp11-kit0, libpam0g, libpixman-1-0, libstdc++6, libtasn1-6, libx11-6, libxau6, libxcb1, libxdmcp6, libxext6, libxfont-dev, libxtst6, zlib1g, libglu1-mesa, libxcursor1, libxinerama1, libxfixes3, x11-xkb-utils
Recommends: xfonts-base, x11-xserver-utils
Suggests: xtigervncviewer, tigervnc-java
Description: virtual network computing server software
 Virtual Network Computing (VNC) is a remote display system which allows you to
 view and interact with a virtual desktop environment that is running on another
 computer on the network.  Using VNC, you can run graphical applications on a
 remote machine and send only the display from these applications to your local
 machine.  VNC is platform-independent and supports a wide variety of operating
 systems and architectures as both servers and clients.
 .
 TigerVNC is a high-speed version of VNC based on the RealVNC 4 and X.org code
 bases.  TigerVNC started as a next-generation development effort for TightVNC
 on Unix and Linux platforms, but it split from its parent project in early 2009
 so that TightVNC could focus on Windows platforms.  TigerVNC supports a variant
 of Tight encoding that is greatly accelerated by the use of the libjpeg-turbo
 JPEG codec.

Package: xtigervncviewer
Architecture: any
Provides: vncviewer, vnc-viewer
Depends: libc6, libexpat1, libfontconfig1, libfreetype6, libgcc1, libgnutls30, libjpeg-turbo8, libp11-kit0, libpng16-16, libstdc++6, libtasn1-6, libx11-6, libxau6, libxcb1, libxdmcp6, libxext6, libxft2, libxrender1, zlib1g, libglu1-mesa, libxcursor1, libxinerama1, libxfixes3, libfltk1.3, libfltk-images1.3
Recommends: xfonts-base
Suggests: tigervncserver, ssh
Description: virtual network computing client software for X
 Virtual Network Computing (VNC) is a remote display system which allows you to
 view and interact with a virtual desktop environment that is running on another
 computer on the network.  Using VNC, you can run graphical applications on a
 remote machine and send only the display from these applications to your local
 machine.  VNC is platform-independent and supports a wide variety of operating
 systems and architectures as both servers and clients.
 .
 TigerVNC is a high-speed version of VNC based on the RealVNC 4 and X.org code
 bases.  TigerVNC started as a next-generation development effort for TightVNC
 on Unix and Linux platforms, but it split from its parent project in early 2009
 so that TightVNC could focus on Windows platforms.  TigerVNC supports a variant
 of Tight encoding that is greatly accelerated by the use of the libjpeg-turbo
 JPEG codec.

Package: tigervnc-java
Architecture: any
Suggests: tigervncserver
Provides: vncviewer, vnc-viewer
Depends:  default-jre
Description: TigerVNC java applet
 Virtual Network Computing (VNC) is a remote display system which allows you to
 view and interact with a virtual desktop environment that is running on another
 computer on the network.  Using VNC, you can run graphical applications on a
 remote machine and send only the display from these applications to your local
 machine.  VNC is platform-independent and supports a wide variety of operating
 systems and architectures as both servers and clients.
 .
 TigerVNC is a high-speed version of VNC based on the RealVNC 4 and X.org code
 bases.  TigerVNC started as a next-generation development effort for TightVNC
 on Unix and Linux platforms, but it split from its parent project in early 2009
 so that TightVNC could focus on Windows platforms.  TigerVNC supports a variant
 of Tight encoding that is greatly accelerated by the use of the libjpeg-turbo
 JPEG codec.

=== contrib/packages/deb/ubuntu-xenial/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 by Joey Hess.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS   := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

export CFLAGS CPPFLAGS CXXFLAGS LDFLAGS

NUMJOBS := -j$(shell nproc)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif
SOURCE_NAME    := tigervnc
SOURCE_VERSION := $(shell dpkg-parsechangelog | awk -F': ' '/^Version: / {print $$2}')
BUILDER=For technical support please see http://sourceforge.net/projects/tigervnc/support
libdir = /usr/lib/$(DEB_HOST_MULTIARCH)


ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -O2 -fPIC
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

export CC = gcc

# use xorg sources as shipped in xorg-server-source package
XORG_SOURCE_ARCHIVE = /usr/src/xorg-server.tar.xz

xorg-source-stamp: $(XORG_SOURCE_ARCHIVE)
	tar -C unix/xserver -axf $(XORG_SOURCE_ARCHIVE) --strip-components=1
	patch -p1 < debian/xorg-source-patches/xserver118-patch.patch
	cd unix/xserver && patch -p1 < ../xserver118.patch
	patch -p1 < debian/xorg-source-patches/516_tigervnc-xorg-manpages.patch
	touch xorg-source-stamp

configure: config-stamp
config-stamp: xorg-source-stamp
	dh_testdir
	# Add here commands to configure the package.
	cmake -G"Unix Makefiles" \
		-DBUILD_STATIC=off \
		-DCMAKE_INSTALL_PREFIX:PATH=/usr \
		-DCMAKE_INSTALL_LIBEXECDIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_INSTALL_UNITDIR:PATH=/lib/systemd/system
	(cd unix/xserver; \
	export PIXMANINCDIR=/usr/include/pixman-1; \
	autoreconf -fiv; \
  patch -p1 -i ../../debian/xorg-source-patches/debian_libtool.patch; \
	./configure --prefix=/usr \
		--disable-silent-rules \
		--disable-static \
		--without-dtrace \
		--disable-strict-compilation \
		--disable-debug \
		--disable-unit-tests \
		--with-int10=x86emu \
		--with-extra-module-dir="/usr/lib/${DEB_HOST_MULTIARCH}/xorg/extra-modules,/usr/lib/xorg/extra-modules" \
		--with-os-vendor="$(VENDOR)" \
		--with-builderstring="$(SOURCE_NAME) $(SOURCE_VERSION) ($(BUILDER))" \
		--with-xkb-path=/usr/share/X11/xkb \
		--with-xkb-output=/var/lib/xkb \
		--with-default-xkb-rules=evdev \
		--disable-devel-docs \
		--enable-mitshm \
		--enable-xres \
		--disable-xcsecurity \
		--disable-tslib \
		--enable-dbe \
		--disable-xf86bigfont \
		--disable-dpms \
		--disable-config-hal \
		--disable-config-udev \
		--disable-xorg \
		--disable-xquartz \
		--disable-xwin \
		--disable-xfake \
		--disable-install-setuid \
		--with-default-font-path="/usr/share/fonts/X11/misc,/usr/share/fonts/X11/cyrillic,/usr/share/fonts/X11/100dpi/:unscaled,/usr/share/fonts/X11/75dpi/:unscaled,/usr/share/fonts/X11/Type1,/usr/share/fonts/X11/100dpi,/usr/share/fonts/X11/75dpi,/var/lib/defoma/x-ttcidfont-conf.d/dirs/TrueType,built-ins" \
		--enable-aiglx \
		--enable-composite \
		--enable-record \
		--enable-xv \
		--enable-xvmc \
		--enable-dga \
		--enable-screensaver \
		--enable-xdmcp \
		--enable-xdm-auth-1 \
		--enable-glx \
		--disable-dri --enable-dri2 --enable-dri3 \
		--enable-xinerama \
		--enable-xf86vidmode \
		--enable-xace \
		--enable-xfree86-utils \
		--disable-dmx \
		--disable-xvfb \
		--disable-xnest \
		--disable-kdrive \
		--disable-xephyr \
		--enable-xfbdev \
		--with-sha1=libgcrypt \
		--enable-xcsecurity \
		--disable-docs \
		--disable-selective-werror)
	touch config-stamp

build-arch: config-stamp build-arch-stamp
build-arch-stamp:
	dh_testdir

	# Add here command to compile/build the package.
	# Build first things.
	# Build Xvnc
	make $(NUMJOBS) LDFLAGS="-lpng"
	make $(NUMJOBS) -C unix/xserver

	touch build-arch-stamp

build-indep: config-stamp  build-indep-stamp
build-indep-stamp:
	dh_testdir

	# Add here command to compile/build the arch indep package.
	# It's ok not to do anything here, if you don't need to build
	#  anything for this package.
	#/usr/bin/docbook-to-man debian/vnc.sgml > vnc.1
	(cd media;make)
	#(cd java;cmake -G"Unix Makefiles";make)

	touch build-indep-stamp

build: build-arch build-indep

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp config-stamp

	# Add here commands to clean up after the build process.
	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_prep
	dh_installdirs
	# Add here commands to install the package into debian/vnc.
	make install DESTDIR=$(CURDIR)/debian/tigervncserver
	(cd unix/xserver/hw/vnc; make install DESTDIR=$(CURDIR)/debian/tigervncserver)
	# rename server files to tigervnc specific names
	mv $(CURDIR)/debian/tigervncserver/usr/bin/Xvnc \
		$(CURDIR)/debian/tigervncserver/usr/bin/Xtigervnc
	mv $(CURDIR)/debian/tigervncserver/usr/bin/vncconfig \
		$(CURDIR)/debian/tigervncserver/usr/bin/tigervncconfig
	mv $(CURDIR)/debian/tigervncserver/usr/bin/vncpasswd \
		$(CURDIR)/debian/tigervncserver/usr/bin/tigervncpasswd
	mv $(CURDIR)/debian/tigervncserver/usr/bin/x0vncserver \
		$(CURDIR)/debian/tigervncserver/usr/bin/x0tigervncserver
	mv $(CURDIR)/debian/tigervncserver/usr/sbin/vncsession \
		$(CURDIR)/debian/tigervncserver/usr/sbin/tigervncsession
	mv $(CURDIR)/debian/tigervncserver/usr/lib/$(DEB_HOST_MULTIARCH)/vncserver \
		$(CURDIR)/debian/tigervncserver/usr/lib/$(DEB_HOST_MULTIARCH)/tigervncserver
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/vncconfig.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/tigervncconfig.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/vncpasswd.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/tigervncpasswd.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/x0vncserver.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/x0tigervncserver.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/Xvnc.1 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man1/Xtigervnc.1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man8/vncsession.8 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man8/tigervncsession.8
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man8/vncserver.8 \
		$(CURDIR)/debian/tigervncserver/usr/share/man/man8/tigervncserver.8
	# delete development files
	rm -f $(CURDIR)/debian/tigervncserver/usr/lib/xorg/modules/extensions/libvnc.la
	# move viewer files to viewer package, rename on the fly
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/bin
	mv $(CURDIR)/debian/tigervncserver/usr/bin/vncviewer \
		$(CURDIR)/debian/xtigervncviewer/usr/bin/xtigervncviewer
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share/man/man1
	mv $(CURDIR)/debian/tigervncserver/usr/share/man/man1/vncviewer.1 \
		$(CURDIR)/debian/xtigervncviewer/usr/share/man/man1/xtigervncviewer.1
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share
	mv $(CURDIR)/debian/tigervncserver/usr/share/applications \
		$(CURDIR)/debian/xtigervncviewer/usr/share/
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share
	mv $(CURDIR)/debian/tigervncserver/usr/share/icons \
		$(CURDIR)/debian/xtigervncviewer/usr/share/
	# tigervnc-java
	#mkdir -p $(CURDIR)/debian/tigervnc-java/usr/share
	#(cd java; make install DESTDIR=$(CURDIR)/debian/tigervnc-java/usr/share)
	# install additional license files
	mkdir -p $(CURDIR)/debian/xtigervncviewer/usr/share/doc/xtigervncviewer
	cp $(CURDIR)/debian/tigervncserver/usr/share/doc/tigervnc/* \
